<?php 

/*

Felix's web proxy for ftp v1.0

  Since one of the function(ftp_scandir) is modified based on an
FTP class designed to work with ftp for phpWebFtp v4.0, and
phpWebFtp is released under the GPL 2, so I think this should be
released under the GPL 2 as well.

  Hope it'll be useful for someone.

  Note: extension(mbstring) is required.

  Note: the original source is encoded with UTF-8, which may not be
compatible with some FTP server using GB2312 and so on, so please 
convert it to your desired encoding, and don't forget to modify 
the line specifying the encoding for IE/firefox in this format:
<meta http-equiv="content-type" content="text/html; charset=utf-8"/>

  Any problem, mail to felix021[at]gmail.com, or visit 
             http://www.19880711.com (in Chinese)

*/
    ob_start();
    session_start();

    $default_host = "localhost";
    $default_port = "21";
    $default_expire = 30; //second
    $default_user = "anonymous";
    $default_pass = "";
    $default_pasv = false; //don't use pasv mode by default
    $privilege_pass = "felix021"; //ignore size limit;
    $max_download_size = 10 * 1048576; // 1 MB = 1048576 B
    $detect_encoding = "UTF-8, GBK, GB2312, ASCII, JIS, eucjp-win, sjis-win"; //add your encoding here

    if($_GET['act'] == "logout"){
        session_destroy();
        header("location: {$_SERVER['PHP_SELF']}");
        exit;
    }else if($_GET['act'] == "dl"){
        if(!isset($_SESSION['user'])){
            echo "<a href=\"{$_SERVER['PHP_SELF']}\">Please login first!</a>\n";
            exit;
        }
        set_time_limit(0);
        $host = $_SESSION['host'];
        $user = $_SESSION['user'];
        $pass = $_SESSION['pass'];
        $pasv = $_SESSION['pasv'];
        $port = $_SESSION['port'];
        $expire = $_SESSION['expire'];
        $filename = $_GET['file'];
        $downloadname = basename($filename);
        $encoding = mb_detect_encoding($downloadname, "UTF-8, GBK, GB2312, ASCII");
        if(eregi("msie", $_SERVER['HTTP_USER_AGENT']) && eregi("zh-cn", $_SERVER['HTTP_ACCEPT_LANGUAGE'])){
            $downloadname = mb_convert_encoding($downloadname, "GBK", $encoding);
        }
        if(!$_SESSION['priv']){
            if(base64_decode($_GET['s']) >= $max_download_size){
                error("File size too large for downloading!");
                exit;
            }
        }
        if(!$conn_id = ftp_connect_login($host,$port, $expire, $pasv, $user, $pass)){
            error('Download: unable to connect!', false);
            exit;
        }
        ob_start();
        $fp = fopen("php://output", "w+");
        if(@ftp_fget($conn_id, $fp, $filename, FTP_BINARY)){
            header("Content-Disposition: attachment; filename=" . $downloadname);
            header("Content-type: application/octetstream");
            header("Pragma: ");
            header("Cache-Control: cache");
            header("Expires: 20");
            ob_end_flush();
            fclose($fp);
        }else{
            error("Fail to download!");
            exit;
        }
        ftp_close($conn_id);
        exit;
    }else if($_GET['act'] == 'msg'){
        error($_GET['msg']);
        exit;
    }
?>
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8"/>
<title>Felix's web proxy for ftp~~~</title>
<style type="text/css">
body{font-family:arial;font-size:14px;text-align:center;}
a{color:blue;text-decoration:none;}
a:hover{color:red;text-decoration:underline;}
td{text-align:center;font-family:arial;font-size:14px;}
.tra{background-color:#FFF;}
.trb{background-color:#DDD;}
.trblack{background-color:#888;height:5px;}
#p1{text-align:center;font-family:arial;font-size:28px;}
#footer{text-align:center;font-family:arial;font-size:16px;}
</style>
</head>
<body>
<p id="p1">Welcome to Felix's web proxy for ftp v1.0 :)</p>
<?php
    if( !isset($_POST['user']) && !isset($_SESSION['user']) ){
?>
<form method="post">
<table align="center" border="1" cellspacing="1" cellpadding="5">
<tr>
    <td>Host</td>
    <td><input type="text" name="host" value="<?php echo $default_host; ?>"/>:<input type="text" style="width:30px" name="port" value="<?php echo $default_port; ?>"/></td>
</tr>
<tr>
    <td>Timeout: <input type="text" style="width:30px" name="expire" value="<?php echo $default_expire; ?>"/></td>
    <td><input type="checkbox" <?php echo ($default_pasv?"checked=\"checked\"":"");?> name="pasv" value="1"/>PASV MODE</td>
</tr>
<tr>
    <td>USERNAME</td><td><input type="text" name="user" value="<?php echo $default_user; ?>"/></td>
</tr>
<tr>
    <td>PASSWORD</td><td><input type="password" name="pass" value="<?php echo $default_pass; ?>"/></td>
</tr>
<tr>
    <td>Privilege Pass</td><td><input type="password" name="priv" value="<?php echo $default_pass; ?>"/></td>
</tr>
<tr>
    <td colspan="2"><input type="submit" value="Login"/></td>
</tr>
</table>
</form>
<?php
    }else if(isset($_POST['user'])){
        $user = $_POST['user'];
        if(empty($user)) $user = "anonymous";
        $pass = $_POST['pass'];
        if(empty($pass)) $pass = "anonymous";
        $port = $_POST['port'];
        if(empty($port)) $port = 21;
        $expire = $_POST['expire'];
        if(empty($expire)) $expire = 30;
        $pasv = empty($_POST['pasv'])?false:true;
        $host = str_replace("ftp://", "", $_POST['host']);
        $priv = $_POST['priv'];
        if(empty($expire)) $expire = 30;
        if(empty($host)){
            error('Hostname can not be empty, please input again! <a href="javascript:history.back();">back</a>', false);
            session_destroy();
            htmlfooter();
            exit;
        }
        $_SESSION['host'] = $host;
        $_SESSION['user'] = $user;
        $_SESSION['pass'] = $pass;
        $_SESSION['port'] = $port;
        $_SESSION['expire'] = $expire;
        $_SESSION['pasv'] = $pasv;
        if($priv == $privilege_pass) $_SESSION['priv'] = true;
        else $_SESSION['priv'] = false;
        if(!$conn_id = ftp_connect_login($host,$port, $expire, $pasv, $user, $pass)){
            error('Login: unable to connect! <a href="javascript:history.back();">back</a>', false);
            session_destroy();
        }else{
            ftp_listdir();
            ftp_close($conn_id);
        }
    }else if(isset($_SESSION['user'])){
        $host = $_SESSION['host'];
        $user = $_SESSION['user'];
        $pass = $_SESSION['pass'];
        $pasv = $_SESSION['pav'];
        $port = $_SESSION['port'];
        $expire = $_SESSION['expire'];
        $dir = $_GET['dir'];
        if(!$conn_id = ftp_connect_login($host,$port, $expire, $pasv, $user, $pass)){
            error('Opening folder: unable to connect! <a href="javascript:history.back();">back</a>', false);
            session_destroy();
        }else{
            ftp_listdir($dir);
            ftp_close($conn_id);
        }
    }

htmlfooter();


/*-------------------------------------------*/
    function htmlfooter(){
?>
<p>
<div id="footer">
Powered by Felix021 @ <a href="http://www.19880711.com">http://www.19880711.com</a><br/>
Released under <a href="http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt" target="_blank">GPL2</a>
</div></p>
</body>
</html>
<?php
        exit;
    }
    function alert($msg){
        $msg = addslashes($msg);
        echo <<<eot
<script language="javascript">
alert('{$msg}');
</script>
eot;
    }
    
    function redirect($url){
        echo <<<eot
<script language="javascript">
window.location = '{$url}';
</script>
eot;
    }

    function error($msg, $encode = true){
        if($encode)$msg = htmlspecialchars($msg);
        echo <<<eot
<div style="font-size:18px;text-align:center;color:red;font-weight:bold">{$msg}</div>
eot;
    }
    
    function ftp_connect_login($host, $port, $expire, $pasv, $user, $pass){
        $conn_id = @ftp_connect($host, $port, $expire);
        if(!$conn_id)return false;
        if(!@ftp_login($conn_id, $user, $pass))return false;
        if($pasv) @ftp_pasv($conn_id, true);
        else @ftp_pasv($conn_id, false);
        return $conn_id;
    }

    function ftp_is_dir($folder) {
        global $conn_id;
        if (@ftp_chdir($conn_id, $folder)) {
            ftp_chdir($conn_id, '..');
            return true;
        } else {
            return false;
        }
    }

    function ftp_dirname($file){
        $len = strlen($file);
        for($i = $len - 1; $i > 0; $i--){
            if(substr($file, $i, 1) == "/") break;
        }
        return substr($file, 0, $i);
    }

    function size2str($size){
        if($size == -1)return "Unknown Size";
        $level = 0;
        $levelstr = array("B", "KB", "MB", "GB");
        while($size >= 1024){
            $size /= 1024;
            $level++;
        }
        return (round($size, 2).$levelstr[$level]);
    }

    function ftp_listdir($dir = ""){
        global $conn_id, $detect_encoding;
        $list = ftp_scandir($conn_id, $dir);
        //var_dump($list);
        //natcasesort($list);
        $direncoded = $dir;
        $encoding = mb_detect_encoding($direncoded, $detect_encoding);
        $direncoded = mb_convert_encoding($direncoded, "UTF-8", $encoding);
        $direncoded = htmlspecialchars($direncoded);
        echo "<p>[ Current Path: <span style=\"color:red\">" . (empty($direncoded)?"/":$direncoded), "</span> ]&nbsp;&nbsp;&nbsp;&nbsp;";
        echo "[ <a href=\"{$_SERVER['PHP_SELF']}?act=logout\">Logout</a> ]</p>\n";
        echo '<table align="center" width="800" border="1" cellspacing="0" cellpadding="5">', "\n";
        if($dir != "/"){
            $url = $_SERVER['PHP_SELF'] . "?dir=" . urlencode(ftp_dirname($dir));
            echo "<tr class=\"tra\"><td>Directory</td><td><a href=\"{$url}\">UP to parent folder</a></td></tr>\n";
        }
        $i = 0;
        echo "<tr class=\"trblack\"><td colspan=\"2\"></td></tr>";
        if($list != false && count($list) != 0){
            foreach($list as $file){
                if(!$file['is_dir']) continue;
                if($i % 2) $class = "tra";
                else $class = "trb";
                $name = $file['name'];
                $url = $_SERVER['PHP_SELF'] . "?dir=" . urlencode("$dir/$name");
                if(!empty($dir) && strpos($name, $dir) === 0){
                    $count = 1;
                    $name = str_replace("$dir", "", $name, $count);
                }
                if(substr($name, 0, 1) == '/')
                    $name = substr($name, 1);
                $encoding = mb_detect_encoding($name, $detect_encoding);
                $name = mb_convert_encoding($name, "UTF-8", $encoding);
                $name = htmlspecialchars($name);
                echo "<tr class=\"{$class}\"><td>Directory</td><td><a href=\"{$url}\">{$name}</a></td></tr>\n";
                $i++;
            }
            echo "<tr class=\"trblack\"><td colspan=\"2\"></td></tr>";
            foreach($list as $file){
                if($file['is_dir'] || $file['is_link']) continue;
                if($i % 2) $class = "tra";
                else $class = "trb";
                $name = $file['name'];
                $url = $_SERVER['PHP_SELF'] . "?act=dl". "&s=" . base64_encode($file['size']) ."&file=" . urlencode("$dir/$name");
                $url .= "&s=" . base64_encode($file['size']);
                if(!empty($dir) && strpos($name, $dir) === 0){
                    $count = 1;
                    $name = str_replace("$dir", "", $name, $count);
                }
                if(substr($name, 0, 1) == '/')
                    $name = substr($name, 1);
                $encoding = mb_detect_encoding($name, $detect_encoding);
                $name = mb_convert_encoding($name, "UTF-8", $encoding);
                $name = htmlspecialchars($name);
                $size = size2str($file['size']);
                echo "<tr class=\"{$class}\"><td>File({$size})</td><td><a target=\"_blank\" href=\"{$url}\">{$name}</a></td></tr>\n";
                $i++;
            }
            echo "<tr class=\"trblack\"><td colspan=\"2\"></td></tr>";
            foreach($list as $file){
                if(!$file['is_link']) continue;
                if($i % 2) $class = "tra";
                else $class = "trb";
                $name = $file['name'];
                $url1 = $_SERVER['PHP_SELF'] . "?dir=" . urlencode("$dir/$name");
                $url2 = $_SERVER['PHP_SELF'] . "?act=dl". "&s=" . base64_encode($file['size']) ."&file=" . urlencode("$dir/$name");
                $url .= "&s=" . base64_encode($file['size']);
                if(!empty($dir) && strpos($name, $dir) === 0){
                    $count = 1;
                    $name = str_replace("$dir", "", $name, $count);
                }
                if(substr($name, 0, 1) == '/')
                    $name = substr($name, 1);
                $encoding = mb_detect_encoding($name, $detect_encoding);
                $name = mb_convert_encoding($name, "UTF-8", $encoding);
                $name = htmlspecialchars($name);
                $size = size2str($file['size']);
                echo "<tr class=\"{$class}\"><td>Link(maybe file or dir)</td><td><span style=\"color:red\">{$name}</span> - [open as <a target=\"_blank\" href=\"{$url1}\">DIR</a> or <a target=\"_blank\" href=\"{$url2}\">FILE</a>]</td></tr>\n";
                $i++;
            }
        }else{
            echo '<tr><td colspan="2">No file exists here.</td></tr>', "\n";
        }
        echo '</table>', "\n";
    }

	function ftp_scandir($conn_id, $directory) {
        /* 
            This function is modified based on an FTP class designed 
            to work with FTP Connections from phpWebFtp v4.0
            @author Edwin van Wijk, www.v-wijk.net
            @email info@vwijk.net
        */

		$list= array();
		$list = ftp_rawlist($conn_id, "-a " . $directory);
        if(count($list) == 0 || $list == false) return false;
        $systype = strtoupper(ftp_systype($conn_id));
		if ($systype == "UNIX")
		{
			$regexp = "([-ltdrwxs]{10})[ ]+([0-9]+)[ ]+([A-Z|0-9|-|_]+)[ ]+([A-Z|0-9|-|_]+)[ ]+([0-9]+)[ ]+([A-Z]{3}[ ]+[0-9]{1,2}[ ]+[0-9|:]{4,5})[ ]+(.*)";
			$i=0;
			foreach ($list as $line) 
			{
				$is_dir = $is_link = FALSE;
				$target = "";

				if (eregi($regexp, $line, $regs))
				{
					if (!eregi("^[.]", $regs[7])) //hide hidden files
					if (!eregi("^[.]{2}", $regs[7])) // don't hide hidden files
					{
						$i++;
						if (eregi("^[d]", $regs[1]))
						{
							$is_dir = TRUE;
						}
						elseif (eregi("^[l]", $regs[1])) 
						{ 
							$is_link = TRUE;
							list($regs[7], $target) = split(" -> ", $regs[7]);
						}

						//Get extension from file name
						$regs_ex = explode(".",$regs[7]);
						if ((!$is_dir)&&(count($regs_ex) > 1))
						   $extension = $regs_ex[count($regs_ex)-1];
						else $extension = "";
						$files[$i] = array (
						"is_dir"	=> $is_dir,
						"extension"	=> $extension,
						"name"		=> $regs[7],
						"perms"		=> $regs[1],
						"num"		=> $regs[2],
						"user"		=> $regs[3],
						"group"		=> $regs[4],
						"size"		=> $regs[5],
						"date"		=> $regs[6],
						"is_link"	=> $is_link,
						"target"	=> $target );						
					}
				}
			}
		}
		else
		{
			$regexp = "([0-9\-]{8})[ ]+([0-9:]{5}[APM]{2})[ ]+([0-9|<DIR>]+)[ ]+(.*)";
			foreach ($list as $line) 
			{
				$is_dir = false;
				if (eregi($regexp, $line, $regs)) 
				{
					if (!eregi("^[.]", $regs[4]))
					{
						if($regs[3] == "<DIR>")
						{
							$is_dir = true;
							$regs[3] = '';
						}
						$i++;
	
						// Get extension from filename
						$regs_ex = explode(".",$regs[4]);
						if ((!$is_dir)&&(count($regs_ex) > 1))
						   $extension = $regs_ex[count($regs_ex)-1];
						else $extension = "";

						$files[$i] = array (
							"is_dir"	=> $is_dir,
							"extension"	=> $extension,
							"name"		=> $regs[4],
							"date"		=> $regs[1],
							"time"		=> $regs[2],
							"size"		=> $regs[3],
							"is_link"	=> 0,
							"target"	=> "",
							"num"		=> "" );
					}
				}
			}
		}
		return $files;
	}
?>